/* lspkg - list installed packages */
call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
call SysLoadFuncs

call RxFuncAdd 'UX2LoadFuncs','UX2Util','UX2LoadFuncs'
call UX2LoadFuncs

say "                                                      install         "
say "package                                 version       date        pkg date"
say "-----------------------------------------------------------------------------"

call SysFileTree UX2Canonicalize('/var/log/packages/*'),file.,'F'
do i=1 to file.0
  instdate=word(file.i,1)
  pkginfo=word(file.i,words(file.i))
  pkg=UX2BaseName(pkginfo)
  call getpkginfo 'DATE',pkginfo
  if pkginfo.0=1 then 
     pkgdate=pkginfo.1
  else
     pkgdate='????????'
  call getpkginfo 'VERSION',pkginfo
  if pkginfo.0=1 then
     version=pkginfo.1
  else
     version='?'
  say pkg||copies(' ',40-length(pkg))||version||copies(' ',14-length(version))||instdate"     "pkgdate
end

exit

getpkginfo: procedure expose tmp pkginfo. 

parse arg keyword,pkginfofile

rc=SysFileSearch(keyword,pkginfofile,'tmppkg.','C')
if rc \=0 then
  return 1
else
do
  pkginfo.0=0
  j=1
  if tmppkg.0>0 then
  do
    do i=1 to tmppkg.0
       tmppkg.i=translate(tmppkg.i," ",d2c(9))
       if word(tmppkg.i,1)=keyword then
       do
          pkginfo.j=delword(tmppkg.i,1,1)
          j=j+1
          pkginfo.0=pkginfo.0+1
       end  /* if word... */
    end   /* i=1 to tmppkg.0 */
  end /* if tmppkg.0... */
  return 0
end  /* else */
